
package de.ivu.elect.presentation.ergebnis.menu;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.boundary.SitzeExtendedDAO;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.sitzberechnung.control.SitzberechnungsalgorithmusFinder;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahldurchfuehrung;
import de.ivu.elect.presentation.ergebnis.WasSitzeSearchView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class SitzeAnzeigenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlSessionSelect wahlSessionSelect;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  @Inject
  private transient SitzberechnungsalgorithmusFinder sitzberechnungsalgorithmusFinder;

  @Inject
  private transient SitzeExtendedDAO sitzeExtendedDAO;

  public SitzeAnzeigenMenuItemEntry() {
    super();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  public boolean isSitzeInErgebnis() {
    Ergebnis ergebnis = ergebnisSessionSelect.getEntity();
    if (ergebnis == null) {
      return false;
    } else {
      return sitzeExtendedDAO.findByCountErgebnis(ergebnis) > 0;
    }
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.SITZE_SEARCH) && (isSitzeInErgebnis() || wahlSessionSelect.isSelected() && sitzberechnungsalgorithmusFinder
        .getSitzberechnungsalgorithmus(wahlSessionSelect.getEntity().castTo(Wahldurchfuehrung.class).getEntity()).isVergibtSitze());
  }

  @Override
  public boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this) || (ergebnisSessionSelect.getEntity().isStatusUnbekannt() && !isSitzeInErgebnis());
  }

  @Override
  public String getTargetViewId() {
    return WasSitzeSearchView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "ergebnis.sitze.anzeigen.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCalculate();
  }
}
